con
  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000

obj
  s : "BigSerial" ' big spin serial variation which runs fine with normal spin

pub main | n,time
  s.start(31,30,0,115200)
  waitcnt(clkfreq+cnt)
  s.str(string("Starting "))

  repeat n from 0 to 26

    time := cnt
    result := fibo(n)
    time := cnt - time

    s.str(string($d,"fibo "))
    s.dec(n)
    s.str(string(" = "))
    s.dec(result)
    s.str(string(" in "))
    s.dec(time/(_clkfreq/1000))
    s.str(string(" ms"))


pub fibo(n)

  if (n < 2)
    return n
  else
    return fibo(n - 1) + fibo(n - 2)

{
Hardware  |  Language  |  FIBO(20) time  |  FIBO 0 to 26
----------+------------+-----------------+--------------
C3        |  SPIN      |  547ms          |  30s
SDRAM     |  SPIN      |  547ms          |  30s
C3        |  BigSPIN   |  3601ms         |  2m53s
SDRAM     |  BigSPIN   |  2858ms         |  2m19s
C3        |  ZOG C     |  3644ms         |  3m18s
SDRAM     |  ZOG C     |  2773ms         |  2m18s
----------+------------+-----------------+--------------
}
