CON

  HUB_TOP       = $7FF0

CON
'' add/or HUB_ADDR with an address to make sure it's accessed as HUB RAM
	HUB_ADDR 	= $1000_0000

PUB setHubByte(varptr, value)
''
''  set variable referenced by varptr to value in HUB RAM to value
''
	byte[varptr|HUB_ADDR] := value

PUB setHubWord(varptr, value)
''
''  set variable referenced by varptr to value in HUB RAM to value
''
	word[varptr|HUB_ADDR] := value

PUB setHubLong(varptr, value)
''
''  set variable referenced by varptr to value in HUB RAM to value
''
	long[varptr|HUB_ADDR] := value

PUB getHubByte(varptr)
''
''  return value of variable referenced by varptr from HUB RAM
''
	return byte[varptr|HUB_ADDR]

PUB getHubWord(varptr)
''
''  return value of variable referenced by varptr from HUB RAM
''
	return word[varptr|HUB_ADDR]

PUB getHubLong(varptr)
''
''  return value of variable referenced by varptr from HUB RAM
''
	return long[varptr|HUB_ADDR]

PUB getHubPtr(varptr)
''
''  return HUB address of varptr
''
	return varptr|HUB_ADDR


{{
 TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}
